/*
*   C Code for a simple application
*
*	This code prints a message using the embedded uart
* 	as stdout. This software is programmed into flash using the 
*   JTAG and flash interface. 
*
*	It tests the UART by outputting information
*	over the UART at a baud rate of 38400 with 8 bits per 
*	character no parity and one stop bit, with no flow control.
*
*   Copyright (c) Altera Corporation 2001.
*   All rights reserved.
*/

#include <stdio.h>
#include "stripe.h"

void Scroll_LED(void);
void delay(int);

volatile unsigned int *LED;

int main(void)
{
	LED = (volatile unsigned int*) EXC_PLD_BLOCK0_BASE;
	
	printf("\r\n");
	printf("****************************************************\r\n");
	printf("**                                                **\r\n");
	printf("** Altera EPXA10 Development Board - I'm alive!!! **\r\n");
	printf("**                                                **\r\n");
	printf("** Look for scrolling LEDs                        **\r\n");
	printf("**                                                **\r\n");
	printf("****************************************************\r\n");

	while (1)
		Scroll_LED();

	return 0;
}

void Scroll_LED(void)
{
	int i;
	int	j;

	j=0x00;
	
	for(i = 0; i < 4; i++)
	{
		*LED = 0x01 << i;
		
		if(j)
		{
			*LED|=0x80;
			j=0x00;
		}
		else
			j=0x01;
		
		delay(1000000);
		printf("LED = 0x%x\r\n", *LED);
		
		
	}
	
	
	for(i = 0; i < 4; i++)
	{
		*LED = 0x08 >> i;

		if(j)
		{
			*LED|=0x80;
			j=0x00;
		}
		else
			j=0x01;
		
		delay(1000000);
		printf("LED = 0x%x\r\n", *LED);
	}
	
		
	return;	
}

void delay(int time)
{
	int i;
	for(i = 0; i < time; i++);
}
