////////////////////////////////////////////////////////////////////////////////
// This confidential and proprietary software may be used only as authorized by
// a licensing agreement from Altera Corporation.
//
// (C) COPYRIGHT 2000 ALTERA CORPORATION
// ALL RIGHTS RESERVED
//
// The entire notice above must be reproduced on all authorized copies and any
// such reproduction must be pursuant to a licensing agreement from Altera.
//
// File     	: ahb_include.v
// Project  	: AHB_bus
// 
// 
// Abstract: AHB include file for AHB_slave
//
////////////////////////////////////////////////////////////////////////////////


/*----------------------------------------------------------------------------
 AHB transfer type macros
----------------------------------------------------------------------------*/
`define IDLE 2'b00
`define BUSY 2'b01
`define NONSEQ 2'b10
`define SEQ 2'b11
/*----------------------------------------------------------------------------
 AHB burst type macros
----------------------------------------------------------------------------*/
`define SINGLE 3'b000	// Single Transfer
`define INCR 3'b001		// Unspecified incrementing
`define WRAP4 3'b010	// 4-beat wrapping
`define INCR4 3'b011	// 4-beat incrementing
`define WRAP8 3'b100	// 8-beat wrapping
`define INCR8 3'b101	// 8-beat incrementing
`define WRAP16 3'b110	// 16-beat wrapping
`define INCR16 3'b111	// 16-beat incrementing
/*----------------------------------------------------------------------------
 AHB hresp macros
----------------------------------------------------------------------------*/
`define OKAY 2'b00
`define ERROR 2'b01
`define RETRY 2'b10
`define SPLIT 2'b11
/*----------------------------------------------------------------------------
 AHB transfer size macros
----------------------------------------------------------------------------*/
`define AHB_BYTE 3'b000
`define AHB_HALF 3'b001
`define AHB_WORD 3'b010
/*----------------------------------------------------------------------------
 AHB hwrite macros
----------------------------------------------------------------------------*/
`define AHB_WRITE 1'b1
`define AHB_READ 1'b0
/*----------------------------------------------------------------------------
AHB Register File Address Map for ALU
----------------------------------------------------------------------------*/
`define OP1   3'b001
`define OP2   3'b010
`define OPER  3'b011
`define RELOW 3'b100
`define REHIG 3'b101
/*----------------------------------------------------------------------------
ALU operations
----------------------------------------------------------------------------*/
`define ADD 2'b01
`define SUB 2'b10
`define MULT 2'b11
/*----------------------------------------------------------------------------
ALU Wait state generation
----------------------------------------------------------------------------*/
`define ADD_WAIT 2
`define SUB_WAIT 2
`define MULT_WAIT 7
/*----------------------------------------------------------------------------
AHB BUS Slave Decode
----------------------------------------------------------------------------*/
`define Slave9  20'b1000_0000_0010_0000_0000		//HEX ADDRESS 80200XXX
`define Slave8  20'b1000_0000_0001_0000_0000		//HEX ADDRESS 80100XXX
`define Slave7  20'b1000_0000_0000_1000_0000 		//HEX ADDRESS 80080XXX
`define Slave6  20'b1000_0000_0000_0100_0000		//HEX ADDRESS 80040XXX
`define Slave5  20'b1000_0000_0000_0010_0000		//HEX ADDRESS 80020XXX
`define Slave4  20'b1000_0000_0000_0001_0000		//HEX ADDRESS 80010XXX
`define Slave3  20'b1000_0000_0000_0000_1000		//HEX ADDRESS 80008XXX
`define Slave2  20'b1000_0000_0000_0000_0100		//HEX ADDRESS 80004XXX
`define Slave1  20'b1000_0000_0000_0000_0010		//HEX ADDRESS 80002XXX
`define Slave0  20'b1000_0000_0000_0000_0001		//HEX ADDRESS 80001XXX
/*----------------------------------------------------------------------------
Interconnect Matrix Slave Decode
----------------------------------------------------------------------------*/
`define Inter_Slave4  3'b001
`define Inter_Slave5  3'b010
`define Inter_Slave6  3'b100
