// Copyright (C) 1991-2001 Altera Corporation
// Any megafunction design, and related net list (encrypted or decrypted),
// support information, device programming or simulation file, and any other
// associated documentation or information provided by Altera or a partner
// under Altera's Megafunction Partnership Program may be used only to
// program PLD devices (but not masked PLD devices) from Altera.  Any other
// use of such megafunction design, net list, support information, device
// programming or simulation file, or any other related documentation or
// information is prohibited for any other purpose, including, but not
// limited to modification, reverse engineering, de-compiling, or use with
// any other silicon devices, unless such use is explicitly licensed under
// a separate agreement with Altera or a megafunction partner.  Title to
// the intellectual property, including patents, copyrights, trademarks,
// trade secrets, or maskworks, embodied in any such megafunction design,
// net list, support information, device programming or simulation file, or
// any other related documentation or information provided by Altera or a
// megafunction partner, remains with Altera, the megafunction partner, or
// their respective licensors.  No other licenses, including any licenses
// needed under any third party's intellectual property, are provided herein.

`include "..\rtl\ahb_include.v"

// TOP MODULE
module regfile (reset,
				address, 
			 	clock,
			    wdata,
			    rdata,
				write,
				clock_en,
				led);
// INPUTS
	input		  clock;			// regfile clock
	input		  clock_en;			// regfile clock enable
	input		  reset;			// reset
	input  [4:0]  address;			// Address bus 16 locations
	input  [31:0] wdata;			// Write data bus
	input		  write;			// High is write Low is read

// OUTPUTS	
	output [31:0] rdata;			// Read Data bus
	output [7:0] led;
	
// Internal Declarations
	reg [31:0] rdata;			    
	reg [31:0] memory;
	reg [7:0] led;	

// Main Code
	always @(posedge clock or negedge reset)
	  begin
		
		if(reset == 1'b0)
		  begin			// Async Reset clear the contents of 
			rdata <= 32'd0;		  	
			memory <= 32'd0;
			led <= 8'd0;
	      end
	
		else if(clock_en)
		  begin
		
			if(write)
		  	  begin
				memory <= wdata;
				led <= wdata;
		  	  end // if
		
			else
		  	  begin
		 		rdata <= memory;
				led <= memory;
		  	  end
		
	     end // elseif
	
	   else
		 begin
		 	rdata <= rdata;
		    led <= led;
	     end
	
      end // always

endmodule
